﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Data;

namespace DrillDownChart
{
    public class SalesDataSet : DataSet
    {
        public SalesDataSet()
        {
            Tables.Add(RegionTable);
            Tables.Add(RepsSalesTable);

        }

        public DataTable RegionTable
        {
            get
            {
                if (_RegionTable == null)
                {
                    List<String> Regions = new List<string>() { "East", "West", "Central", "International", "South" };

                    _RegionTable = new DataTable("Region");
                    _RegionTable.Columns.Add("RegionID", typeof(int));
                    _RegionTable.Columns.Add("RegionName", typeof(string));

                    int i = 0;
                    foreach (var region in Regions)
                    {
                        DataRow row = _RegionTable.NewRow();
                        row["RegionID"] = ++i;
                        row["RegionName"] = region;
                        _RegionTable.Rows.Add(row);
                    }

                }
                return _RegionTable;
            }
        } private DataTable _RegionTable;

        public DataTable RepsSalesTable
        {
            get
            {
                if (_RepsSalesTable == null)
                {
                    List<String> reps = new List<string>() { 
                        "Aaron", "Larry", "Andrew", "Mary", "Sally", "Nguyen", "Francis", 
                        "Jerry", "Danny", "Jim", "Sarah", "Hannah", "Kim", "Gerry", "Bob" };
                    int[] regions = { 1, 2, 3, 1, 4, 2, 4, 3, 1, 2, 2, 3, 5, 5, 5 };
                    int[] sales = { 10440, 17772, 23880, 7663, 21773, 32294, 11983, 14991, 
                                    17946, 8551, 19443, 27887, 30332, 16668, 21225 };

                    _RepsSalesTable = new DataTable("RepsSales");
                    _RepsSalesTable.Columns.Add("ID", typeof(int));
                    _RepsSalesTable.Columns.Add("Name", typeof(string));
                    _RepsSalesTable.Columns.Add("RegionID", typeof(int));
                    _RepsSalesTable.Columns.Add("Sales", typeof(int));

                    for (int i = 0; i < reps.Count; i++)
                    {
                        DataRow row = _RepsSalesTable.NewRow();
                        row["ID"] = i + 1;
                        row["Name"] = reps[i];
                        row["RegionID"] = regions[i];
                        row["Sales"] = sales[i];

                        _RepsSalesTable.Rows.Add(row);
                    }

                }
                return _RepsSalesTable;
            }
        } private DataTable _RepsSalesTable;
    }
}